/*
 *  åѥ PIT(AT91SAM7Sѡ
 */


#ifndef TOPPERS_CHIP_TIMER_H
#define TOPPERS_CHIP_TIMER_H

#include <sil.h>
#include "at91sam7s.h"

/*
 *  ޳ߥϥɥϿΤ
 */
#define INHNO_TIMER    INTNO_SYSIRQ_PID  /* ߥϥɥֹ */
#define INTNO_TIMER    INTNO_SYSIRQ_PID  /* ֹ */
#define INTPRI_TIMER   -6                /* ͥ */
#define INTATR_TIMER   0U                /* ° */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ͤɽη
 */
typedef uint32_t    CLOCK;

/*
 *  
 */
#define F_CPU                47923200
#define PIT_PITEN            ((uint32_t) 0x1 << 24)      // Periodic Interval Timer Enabled
#define PIT_PITIEN           ((uint32_t) 0x1 << 25)      // Periodic Interval Timer Interrupt Enable
#define PIT_PITS             ((uint32_t) 0x1 <<  0)      // Periodic Interval Timer Status

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 */
#define TIMER_CLOCK          300U
#define TO_CLOCK(nume, deno) (TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)       (((SYSUTM) clock) * 1000U / TIMER_CLOCK)

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void    target_timer_initialize(intptr_t exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void    target_timer_terminate(intptr_t exinf);

uint32_t PIT_GetPIVR(void);

extern uint32_t __timer_counter;

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
target_timer_get_current(void)
{
    return(__timer_counter);
}

/*
 *  ޳׵Υå
 */
Inline bool_t
target_timer_probe_int(void)
{
    return(x_probe_int(INTNO_TIMER));
}

/*
 *  ޳ߥϥɥ
 */
extern void    target_timer_handler(intptr_t exno);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CHIP_TIMER_H */
